// @ts-check

/* eslint class-methods-use-this:0 */
'use strict' // Imports

function _typeof(obj) {
	'@babel/helpers - typeof'
	if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
		_typeof = function _typeof(obj) {
			return typeof obj
		}
	} else {
		_typeof = function _typeof(obj) {
			return obj &&
				typeof Symbol === 'function' &&
				obj.constructor === Symbol &&
				obj !== Symbol.prototype
				? 'symbol'
				: typeof obj
		}
	}
	return _typeof(obj)
}

function _classCallCheck(instance, Constructor) {
	if (!(instance instanceof Constructor)) {
		throw new TypeError('Cannot call a class as a function')
	}
}

function _defineProperties(target, props) {
	for (var i = 0; i < props.length; i++) {
		var descriptor = props[i]
		descriptor.enumerable = descriptor.enumerable || false
		descriptor.configurable = true
		if ('value' in descriptor) descriptor.writable = true
		Object.defineProperty(target, descriptor.key, descriptor)
	}
}

function _createClass(Constructor, protoProps, staticProps) {
	if (protoProps) _defineProperties(Constructor.prototype, protoProps)
	if (staticProps) _defineProperties(Constructor, staticProps)
	return Constructor
}

function _createSuper(Derived) {
	return function () {
		var Super = _getPrototypeOf(Derived),
			result
		if (_isNativeReflectConstruct()) {
			var NewTarget = _getPrototypeOf(this).constructor
			result = Reflect.construct(Super, arguments, NewTarget)
		} else {
			result = Super.apply(this, arguments)
		}
		return _possibleConstructorReturn(this, result)
	}
}

function _possibleConstructorReturn(self, call) {
	if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
		return call
	}
	return _assertThisInitialized(self)
}

function _assertThisInitialized(self) {
	if (self === void 0) {
		throw new ReferenceError(
			"this hasn't been initialised - super() hasn't been called"
		)
	}
	return self
}

function _isNativeReflectConstruct() {
	if (typeof Reflect === 'undefined' || !Reflect.construct) return false
	if (Reflect.construct.sham) return false
	if (typeof Proxy === 'function') return true
	try {
		Date.prototype.toString.call(Reflect.construct(Date, [], function () {}))
		return true
	} catch (e) {
		return false
	}
}

function _getPrototypeOf(o) {
	_getPrototypeOf = Object.setPrototypeOf
		? Object.getPrototypeOf
		: function _getPrototypeOf(o) {
				return o.__proto__ || Object.getPrototypeOf(o)
		  }
	return _getPrototypeOf(o)
}

function _inherits(subClass, superClass) {
	if (typeof superClass !== 'function' && superClass !== null) {
		throw new TypeError('Super expression must either be null or a function')
	}
	subClass.prototype = Object.create(superClass && superClass.prototype, {
		constructor: { value: subClass, writable: true, configurable: true },
	})
	if (superClass) _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
	_setPrototypeOf =
		Object.setPrototypeOf ||
		function _setPrototypeOf(o, p) {
			o.__proto__ = p
			return o
		}
	return _setPrototypeOf(o, p)
}

var _require = require('caterpillar'),
	Transform = _require.Transform
/**
Filter the log entires by level.
Extends http://master.caterpillar.bevry.surge.sh/docs/Transform.html
@extends Transform
@example
const logger = require('caterpillar').create()
logger.pipe(require('caterpillar-filter').create()).pipe(process.stdout)
logger.log('info', 'this will be outputted')
logger.log('debug', 'this will be ignored')
logger.setConfig({level: 5})
logger.log('info', 'now even this will be ignored')
logger.log('note', 'but not this')
*/

var Filter = /*#__PURE__*/ (function (_Transform) {
	_inherits(Filter, _Transform)

	var _super = _createSuper(Filter)

	function Filter() {
		_classCallCheck(this, Filter)

		return _super.apply(this, arguments)
	}

	_createClass(Filter, [
		{
			key: 'getInitialConfig',

			/**
    Get the initial configuration.
    @returns {Object}
    */
			value: function getInitialConfig() {
				return {
					level: 6,
				}
			},
			/**
    Empty log entries that are not within our level range.
    Convert the message from Logger into JSON, check its level, if it is above our level, discard it.
    @param {string} message
    @returns {Object?}
    */
		},
		{
			key: 'format',
			value: function format(message) {
				var entry = JSON.parse(message)

				var _this$getConfig = this.getConfig(),
					level = _this$getConfig.level

				return entry.levelNumber > level ? null : entry
			},
		},
	])

	return Filter
})(Transform) // Export

module.exports = Filter
